// --------- библиотеки ---------
// библиотеки для Blynk
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
// библиотеки для управления
#include <Wire.h> // библиотека для работы с шиной i2c
#include <PCF8574.h> // библиотека для PCF8574
// библиотеки для датчика HMC5883
#include <Adafruit_Sensor.h> // библиотека для работы HMC5883
#include <Adafruit_HMC5883_U.h> // библиотека для работы HMC5883
// переменные Blynk
#define BLYNK_PRINT Serial
char auth[] = "TOKEN";
char ssid[] = "SSID";
char pass[] = "PASSWORD";
// часть переменных для управления
PCF8574 pcf20(0x20); // задаем параметры PCF8574, адрес 0х20
byte pcf_byte0; // значение энкодера 1 контакт
byte pcf_byte1; // значение энкодера 2 контакт
byte pcf_byte2; // значение энкодера 3 контакт
int pcf_command; // десятичное значение энкодера
int OUT1=13; // OUT1 - шим двигателя
int OUT2=12; // OUT2 - шим руля
int skorost; // скорость двигателей 
int revers; // направление движение (1 - назад, 0 - вперед)
// направление движения 
// 0 - влево, 1 - 0,3 влево, 2 - 0,6 - влево, 
// 3 - прямо, 4 - 0,6 право, 5 - 0,3 право, 6 - право. 
int Napravlenie = 3; 
int MotorStatus = 0; // статус мотора руля (0 - выключен, 1 крутиться вправо, 2 - крутиться влево)
int millis1 = 0; // прерывание 1
int millis2 = 0; // прерывание 2
// часть переменных для датчиков
int BAT=17;  //  BAT - номер контакта ADC батареи
int Sila, SilaLow = -43;   // Контроль силы сигнала WiFi
int Batareya, BatLow = 400; //Контроль напряжения батареи
String Bat, SilaW; // переменные для величины батареи и сигнала Wi-Fi
Adafruit_HMC5883_Unified mag = Adafruit_HMC5883_Unified(12345); // переменная для HMC5883
float mag_x; // X HMC5883 
float mag_y; // Y HMC5883 
float mag_z; // Z HMC5883 
float mag_k; // Курс HMC5883
int millis3 = 0; // прерывание 3
// ----------------------------------- setup -----------------------------------
void setup() {
  Serial.begin(115200);
  // инициализация Blynk
  Blynk.begin(auth, ssid, pass);
  // для управления
  pcf20.begin(); // инициализация PCF8574  
  ruleStop(); // останавливаем двигатели
  // для датчиков
  pinMode(BAT,INPUT); // инициализация порта для измерения заряда батареи
  if(!mag.begin()) // инициализация HMC5883
  {
    Serial.println("Ooops, no HMC5883 detected ... Check your wiring!");
    while(1);
   }
}
// ----------------------------------- loop -----------------------------------
void loop() {
  // запуск Blynk
  Blynk.run();
  // управление машиной
    // часть управления рулем
    if(millis() >= millis1){
      millis1 = millis()+10; //Обновляем значения раз в 10 миллисекунд
      processRule();
    }
    // управление двигателем
    if(millis() > millis2){
      millis2=millis()+300;       //Обновляем значения раз в 300 миллисекунд
      processMotor();
    }
    // конец управления машиной
  // считывание с датчиков
  if(millis() > millis3){
    millis3=millis()+1000;       //Обновляем значения раз в 1 секунду
    Batare();
    SilaWifi();
    SensorMag();
  }
}
// функции Blynk
BLYNK_WRITE(V1) {
  // параметр джойстика 0 
  // руль, направление движения 
  // 0 - лево, 1 - 0,3 лево, 2 - 0,6 - лево,
  // 3 - прямо
  // 4 - 0,6 право, 5 - 0,3 право, 6 - право.
  Napravlenie = param[0].asInt();
  // параметр джойстика 1
  // управление двигателем
  int coord_y = param[1].asInt(); // мотор -1024 - +1024
  skorost = abs (coord_y);
  if (coord_y < 0) {
    revers = 1;
  } else {
    revers = 0;
  }
}
// ------------------- управление рулем
void ruleLeft() { // руль влево
      analogWrite(OUT2, 800);
      pcf20.write(4, HIGH);
      pcf20.write(5, LOW);
      MotorStatus = 2;
}
void ruleRight() { // руль вправо
      analogWrite(OUT2, 800);
      pcf20.write(4, LOW);
      pcf20.write(5, HIGH);
      MotorStatus = 1;
}
void ruleStop() { // остановить поворот руля
      analogWrite(OUT2, 0);
      pcf20.write(4, LOW);
      pcf20.write(5, LOW);
      MotorStatus = 0;
}
void processRule() {
    pcf_byte0 = pcf20.readButton(0); // данные положение руля конт 1
    pcf_byte1 = pcf20.readButton(1); // данные положение руля конт 2
    pcf_byte2 = pcf20.readButton(2); // данные положение руля конт 3
    pcf_command = pcf_byte0 + pcf_byte1 * 2 + pcf_byte2 * 4; // перевод в десятичную систему

    if (Napravlenie == 6) {
      // направо - 3
      if (pcf_command == 3) {
        // мотор уже в правом положении
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else {
        // мотор не в правом положении, крутим вправо
        if(MotorStatus != 1) {
          ruleRight();
        }
      }
    } else if (Napravlenie == 0) {
      // налево - 0
            if (pcf_command == 0) {
        // мотор уже в левом положении
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else {
        // мотор не в левом положении, крутим налево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      }
    } else if (Napravlenie == 5) {
      // 0.6 - 2
      if (pcf_command == 2) {
        // мотор уже в положении 0,6 вправо, останавливаем
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else if (pcf_command == 3) {
        // мотор справа, крутим влево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      } else if (pcf_command == 0 || pcf_command == 1 || pcf_command == 5 || pcf_command == 4 || pcf_command == 6) {
        // мотор слева, крутим вправо
        if(MotorStatus != 1) {
          ruleRight();
        }
      } else {
        //энкодер стоит между контактами и мотор не крутиться, крутим
        if (pcf_command == 7 && MotorStatus == 0) {
          ruleRight();
        }
      }
    } else if (Napravlenie == 4) {
      // 0.3 направо - 6
      if (pcf_command == 6) {
        // мотор уже в положении 0,3 вправо
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else if (pcf_command == 3 || pcf_command == 2) {
        // мотор справа, крутим налево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      } else if (pcf_command == 0 || pcf_command == 1 || pcf_command == 5 || pcf_command == 4) {
        // мотор слева, крутим вправо
        if(MotorStatus != 1) {
          ruleRight();
        }
      } else {
        // энкодер стоит между контактами и мотор не крутиться, крутим
        if (pcf_command == 7 && MotorStatus == 0) {
          ruleRight();
        }
      }
    } else if (Napravlenie == 1) {
      // 0.6 налево  - 1
      if (pcf_command == 1) {
        // мотор уже в положении 0,6 лево
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else if (pcf_command == 0) {
        // мотор в левом положении, крутим вправо
        if(MotorStatus != 1) {
          ruleRight();
        }
      } else if (pcf_command == 2 || pcf_command == 3 || pcf_command == 4 || pcf_command == 5 || pcf_command == 6){
        // мотор правее, крутим влево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      } else {
        // энкодер стоит между контактами и мотор не крутиться, крутим
        if (pcf_command == 7 && MotorStatus == 0) {
          ruleLeft();
        }
      }
    } else if (Napravlenie == 2) {
      // 0.3 налево  - 5
      if (pcf_command == 5) {
        // мотор уже в положении 0,3 лево
        if(MotorStatus != 0) {
          ruleStop();
        }
      } else if (pcf_command == 0 || pcf_command == 1) {
        // мотор в левом положении, крутим вправо
        if(MotorStatus != 1) {
          ruleRight();
        }
      } else if (pcf_command == 2 || pcf_command == 3 || pcf_command == 4 || pcf_command == 6){
        // мотор правее, крутим влево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      } else {
        // энкодер стоит между контактами и мотор не крутиться, крутим
        if (pcf_command == 7 && MotorStatus == 0) {
          ruleLeft();
        }
      }
    } else {
      // прямо  - 4
      if (pcf_command == 4) {
        // руль стоит прямо, выключаем мотор
        if(MotorStatus != 0) {
          // если мотор не выключен, то выключаем
          ruleStop();
        }
      } else if (pcf_command == 3 || pcf_command == 2 || pcf_command == 6) {
        // руль находиться вправо, крутим налево
        if(MotorStatus != 2) {
          ruleLeft();
        }
      } else if (pcf_command == 0 || pcf_command == 1 || pcf_command == 5) {
        // руль находиться влево, крутим направо
        if(MotorStatus != 1) {
          ruleRight();
        }
      } else {
        // энкодер стоит между контактами и мотор не крутиться, крутим
          if (pcf_command == 7 && MotorStatus == 0) {
            ruleLeft();
          }
        }

    }
}

void processMotor() {
   if (skorost > 200){
      // Если слайдер скорости  > 200
      analogWrite(OUT1, skorost);
      if (revers == 1){
        pcf20.write(6, LOW);
        pcf20.write(7, HIGH);
      } else {
        pcf20.write(6, HIGH);
        pcf20.write(7, LOW);
      }
    }
   else {
      // Если слайдер скорости  < 200 - выключить моторы
      analogWrite(OUT1, 0);
      pcf20.write(6, LOW);
      pcf20.write(7, LOW);
    }
}
// функции для датчиков
// ---------------------- заряд батареи -------------------------
void Batare(){
  Batareya = analogRead(BAT);         // Меряем напряжение батареи
  if (Batareya < BatLow){            // Если напряжение батареи меньше порогового значения
    Bat = "!!!"; // Пишем предупреждение
  }
  else{             // Если норма
    Bat = "";       // Ничего не пишем
  }
}
// ------------------------- Wi-Fi сигнал ----------------------------
void SilaWifi(){
  Sila = WiFi.RSSI();  // Меряем силу сигнала WiFi
  if (Sila < SilaLow){
    SilaW = "!!!";
  }
  else{            // Если норма
    SilaW = "";    // Ничего не пишем
  }
}
// ------------------сенсор HMC5883-----------------------
void SensorMag() {
  sensors_event_t event; 
  mag.getEvent(&event);
  mag_x = event.magnetic.x; // получаем значение X
  mag_y = event.magnetic.y; // получаем значение Y
  mag_z = event.magnetic.z; // получаем значение Z
  // вычисляем курс
  float heading = atan2(event.magnetic.y, event.magnetic.x);
  if(heading < 0)
    heading += 2*PI;
  if(heading > 2*PI)
    heading -= 2*PI;  
  mag_k = heading * 180/M_PI;     
}
